
   import java.util.*;

    public class HangmanWord {
      private String word = null;
      private StringBuffer lettersGuessed;
      private StringBuffer lettersUnguessed;
      private StringBuffer partialWord;
      private int numberOfWordsGuessed;
      private boolean solved;
      private Player player;  
   
       public HangmanWord(String word, Player player) {
         this.word = word.toUpperCase();
         this.player = player;
         lettersUnguessed = new StringBuffer("ABCDEFGHIJKLMNOPQRSTUVWXYZ");
         lettersGuessed = new StringBuffer("");
         partialWord = new StringBuffer("");
      // Create blank word that's the same length as the word to guess
         for (int i = 0; i < word.length(); i++) {
            partialWord.append('_');
         } // end for
         solved = false;
         numberOfWordsGuessed = 0;
      } // end HangmanWord constructor
   
       public String getLettersUnguessed() {
         return lettersUnguessed.toString();
      } // end getLettersUnguessed
   
       public String getLettersGuessed() {
         return lettersGuessed.toString();
      } // end getLettersGuessed
   
       public String getWordGuessed() {
         return word;
      } // end getWordGuessed
   
       public void guess (String guess) {
         guess = guess.toUpperCase();
         if (guess.length() == 0) {
         	// do nothing probably hit the return by mistake
         } 
         else if (guess.length() == 1) {  // only one letter and not a word guessed
         // Check to see that the letter has not already been guessed
            player.incrementLettersGuessed();
            if (lettersGuessed.toString().indexOf(guess)==-1) {
               char guessedChar = guess.toString().charAt(0);
               lettersGuessed.append(guess);
	       
               int i = lettersUnguessed.indexOf(guess);
	       lettersUnguessed.replace(i, i, "");

               i = word.indexOf(guess);
               while (i != -1) {
                  partialWord.setCharAt(i, guessedChar);
                  i = word.indexOf(guess, i+1);              
               } // end while
               if (partialWord.toString().equalsIgnoreCase(word)) {
                  solved = true;
                  player.incrementWordsSolved();
               } // end if
            } // end if		
         } 
         else { // word guessed
            player.incrementWordsGuessed();
            numberOfWordsGuessed++;
            if (guess.equalsIgnoreCase(word)) {
               solved = true;
               player.incrementWordsSolved();
	       partialWord = new StringBuffer(guess);
            
            } // end if
         } // end if
      
      } // end guess
   
       public boolean isSolved() {
         return solved;
      } // end isSolved  
   
       public String getPartialWordGuessed() {
	   StringBuffer temp = new StringBuffer("");
	   for (int i = 0; i < partialWord.length(); i++) {
	       temp.append(partialWord.charAt(i));
	       temp.append(' ');
	   } // end for
         return temp.toString();
      } // end getPartialWordGuessed
   
       public int getNumberOfIncorrectWordsGuessed() {
         return numberOfWordsGuessed;
      } // end getNumberOfIncorrectWordsGuessed
   
       public int getNumberOfLettersGuessed() {
         return lettersGuessed.length();
      } // end getNumberOfLettersGuessed
   } // end class HangmanWord