//
// FILE:     HumanDialog.java
// AUTHOR:   Mark Fienup -- fienup@cs.uni.edu
// DATE:     10/21/05
// COMMENT:  Implementation of a simple radio-button dialog with 
// a human, and displays messages too at the bottom of the dialog frame.  

   import java.awt.*;
   import java.awt.event.*;

    public class HumanDialog {
      private String response;
      private Frame frame;
      private CheckboxGroup checkboxGroup = new CheckboxGroup();
      private ItemListener theListener;
      private Dialog dialog;
   
       public HumanDialog ( Frame containingFrame, String question,  
       	    String [] choices, String [] messages ) {
         frame = containingFrame;
         theListener = new ChoiceListener();
         dialog = new Dialog (containingFrame, true);
         dialog.setSize(400, 200);
         dialog.setTitle(question);
         dialog.setLayout( new GridLayout( choices.length+messages.length, 1 ) );
      
         for (int i = 0; i < choices.length; i++ ) {
            Checkbox cb = new Checkbox(choices[i], false, checkboxGroup);
            cb.addItemListener(theListener);
            dialog.add(cb);
         } // end for
      
         for (int i = 0; i < messages.length; i++) {
            Label messageLabel = new Label( messages[i] );
            dialog.add(messageLabel);
         } // end for
      
      } // end HumanDialog constructor
   
       public String response() {
         return response;
      } // end response
   
       public void show() {
         dialog.show();
      } // end response
   
       private class ChoiceListener implements ItemListener {
          public void itemStateChanged ( ItemEvent e ) {
            response = checkboxGroup.getSelectedCheckbox().getLabel();
            dialog.dispose();
         } // end itemStateChanged
      } // end inner class ChoiceListener
   
   } // end class HumanDialog
