   import java.util.*;
   import java.io.*;

    public class Player {
    
      private String firstName = "joe";     
      private String lastName = "smith";     
      private Date birthday = new Date(); 
      private long totalLettersGuessed = 0;
      private long totalWordsGuessed = 0;
      private long totalWordsSolved = 0;
      private boolean okayFlag;
   
       public Player() {
      
      }
   
       public Player(String firstName, String lastName, Date bday) {
         this.firstName = firstName.toUpperCase();
         this.lastName = lastName.toUpperCase();
         birthday = bday;
         totalLettersGuessed = 0;
         totalWordsGuessed = 0;
         totalWordsSolved = 0;
      } // end Player constructor
    
       public Player(String firstName, String lastName, Date bday, 
        long totalLetters, long totalWords, long totalSolved) {
         this.firstName = firstName.toUpperCase();
         this.lastName = lastName.toUpperCase();
         birthday = bday;
         totalLettersGuessed = totalLetters;
         totalWordsGuessed = totalWords;
         totalWordsSolved = totalSolved;
      } // end Player constructor
   
       public void println(PrintWriter out) {
         try {
            out.print(firstName);
            out.print("\t" + lastName);
            out.print("\t" + birthday.getTime());
            out.print("\t" + totalLettersGuessed);
            out.print("\t" + totalWordsGuessed);
            out.println("\t" + totalWordsSolved);
         	
         } 
             catch (Exception e) {
               System.out.println("Exception " + e + ":  In println of Player");
            } // end try-catch
      } // end println
    
    
   
       public boolean equals (String first, String last) {
         if (firstName.equalsIgnoreCase(first) && lastName.equalsIgnoreCase(last)) {
            return true;
         } // end if
         return false;
      } // end equals
    
    
       public boolean equals (Object arg) {
         if (arg instanceof Player) {
            Player argPlayer = (Player) arg;
            if (firstName.equals(argPlayer.getFirstName()) &&
            lastName.equals(argPlayer.getLastName())) {
               return true;
            } // end if
         } // end if
         return false;
      } // end equals
   
   
       public void updatePlayer(int lettersGuessed, int wordsGuessed, 
       	     int wordsSolved) {
         totalLettersGuessed += lettersGuessed;
         totalWordsGuessed += wordsGuessed;
         totalWordsSolved += wordsSolved;
      } // end updatePlayer
   
   
       public String getName () {
         return firstName + " " + lastName;
      } // end getName
   
    
       public String getFirstName () {
         return firstName;
      } // end getFirstName
   
    
       public String getLastName () {
         return lastName;
      } // end getLastName
   
       public long getAge () {
         Date today = new Date();
         long age = (long) ((today.getTime() - birthday.getTime()) 
                                     / (1000 * 3600 * 24 * 365.25));
         return age;
      } // end getAge
    
       public long getTotalWordsSolved( ) {
         return totalWordsSolved;
      } // end getTotalWordsSolved
   
       public double getAverageWordsGuessed( ) {
         return ((double)totalWordsGuessed) / totalWordsSolved;
      } // end getAverageWordsGuessed
   
   
       public double getAverageLettersGuessed( ) {
         return ((double)totalLettersGuessed) / totalWordsSolved;
      } // end getAverageLettersGuessed
   
       public void incrementLettersGuessed() {
         totalLettersGuessed++;
      } // end incrementLettersGuessed
   
       public void incrementWordsGuessed() {
         totalWordsGuessed++;
      } // end incrementWordsGuessed
   
       public void incrementWordsSolved() {
         totalWordsSolved++;
      } // end incrementWordsSolved
   
   } // end class Player