   import java.util.*;
   import java.io.*;

    public class PlayersInfo {
    
      private ArrayList players = null;
      private static final int NOT_FOUND_FLAG = -1;
   
       public PlayersInfo(String fileName) {
         players = new ArrayList();
         loadPlayers(fileName);
      } // end PlayersInfo constructor
   
       public Player getPlayer(String firstName, String lastName) {
         int foundIndex = locatePlayer(firstName, lastName);
         if (foundIndex == NOT_FOUND_FLAG) {
            return null;
         } // end if
         return (Player) players.get(foundIndex);
      
      } // end getPlayer
   
   
       public boolean addPlayer(Player newPlayer) {
      
         int foundIndex = players.indexOf(newPlayer);
         if (foundIndex == NOT_FOUND_FLAG) {
            players.add( newPlayer );
           return true;
         } // end if
         return false;
      } // end addPlayer
    
    
       public boolean contains(String firstName, String lastName) {
        int foundIndex = locatePlayer(firstName, lastName);
         if (foundIndex == NOT_FOUND_FLAG) {
        
            return false;
         } // end if
        return true;
      
      } // end contains
   
   
   
   
       public void printPlayers() {
         System.out.print("printPlayer: ");
         for (int i = 0; i < players.size(); i++) {
            Player player = (Player) players.get(i);
            System.out.print(player.getFirstName() + " ");
         } // end for
         System.out.println();
      } // end printPlayer
   
   
   
       protected int locatePlayer(String firstName, String lastName) {
      
         for (int i = 0; i < players.size(); i++) {
            Player player = (Player) players.get(i);
            if (player.equals(firstName, lastName)) {
               return i;
            } // end if
         } // end for
         return NOT_FOUND_FLAG;
      } // end locatePlayer
   
       public void save(String fileName) {
         try {
            PrintWriter outputFile = new PrintWriter( new FileWriter( fileName ) );
         
            for (int i = 0; i < players.size(); i++) {
              ((Player) players.get(i)).println(outputFile);
            } // end for
            outputFile.flush();
            outputFile.close();
         } 
             catch (Exception e) {
               System.out.println("Exception " + e 
                  + ": In save of PlayersInfo");
            } // end try-catch
      } // end save
    
       protected void loadPlayers(String fileName) {
         try {
            File tempFile = new File(fileName);
         
            if (!tempFile.exists()) {
               return;
            } // end if
            tempFile = null;
            BufferedReader inputFile = new BufferedReader( new FileReader( fileName ) );
          
            String buffer = null;
         
            while( true )
            {
               buffer = inputFile.readLine();
            
               if ( buffer == null ) 
                  break;
            
               buffer = buffer.toUpperCase();
               String [] playerParts = buffer.split("\t");
               Date bday = new Date();
               bday.setTime(Long.parseLong(playerParts[2]));
               Player temp = new Player(playerParts[0], playerParts[1], bday, 
                                        Long.parseLong(playerParts[3]),
                                        Long.parseLong(playerParts[4]),
                                        Long.parseLong(playerParts[5]));
               addPlayer(temp);
            } // end while
         } 
             catch (Exception e) {
               System.out.println("Exception " + e 
                  + ": In loadPlayers of PlayersInfo");
            } // end try-catch
      } // end loadPlayers
    
   
   } // end class PlayersInfo