//
// FILE:     StringDialog.java
// AUTHOR:   Mark Fienup -- fienup@cs.uni.edu
// DATE:     10/21/05
// COMMENT:  Implementation of a simple dialog with 
// a human that returns a String.  

   import java.awt.*;
//import java.awt.Choice.*;
   import java.awt.event.*;
//import java.awt.CheckboxGroup.*;
//import java.awt.GridLayout;

    public class StringDialog {
      private String response;
      private Frame frame;
      private CheckboxGroup checkboxGroup = new CheckboxGroup();
      private ItemListener theListener;
      private Dialog dialog;
   
       public StringDialog ( Frame containingFrame, String question, 
       	 String [] choices ) {
         frame = containingFrame;
         theListener = new ChoiceListener();
         dialog = new Dialog (containingFrame, true);
         dialog.setSize(400, 200);
         dialog.setTitle(question);
         dialog.setLayout( new GridLayout( choices.length, 1 ) );
      
         for (int i = 0; i < choices.length; i++ ) {
            Checkbox cb = new Checkbox(choices[i], false, checkboxGroup);
            cb.addItemListener(theListener);
            dialog.add(cb);
         } // end for
      
      } // end StringDialog constructor
   
       public String response() {
         return response;
      } // end response
   
       public void show() {
         System.out.println("in show of StringDialog");
         dialog.show();
      } // end response
   
       private class ChoiceListener implements ItemListener {
          public void itemStateChanged ( ItemEvent e ) {
            response = checkboxGroup.getSelectedCheckbox().getLabel();
            dialog.dispose();
         } // end itemStateChanged
      } // end inner class ChoiceListener
   
   } // end class StringDialog
