//
// FILE:     TextDialog.java
// AUTHOR:   Mark Fienup -- fienup@cs.uni.edu
// DATE:     3/5/06
// COMMENT:  Implementation of a simple dialog with 
// a human that asks a question and returns their String response.  

   import java.awt.*;
   import java.awt.event.*;

    public class TextDialog {
      private TextField responseField;
      private String response;
      private Frame frame;
      private Dialog dialog;
    
       public TextDialog ( Frame containingFrame, String question ) {
         frame = containingFrame;
         dialog = new Dialog (containingFrame, true);
         dialog.setSize(400, 200);
         dialog.setTitle(question);
         responseField = new TextField("", 30);
         responseField.addActionListener( new uponEnterKeyPressedListener() );
         dialog.add("Center", responseField);
      } // end TextDialog constructor
    
       public String response() {
         return response;
      } // end response
    
       public void show() {
         dialog.show();
      } // end response
   
    // *************************** Inner classes **************************    
   
       private class uponEnterKeyPressedListener implements ActionListener {
          public void actionPerformed ( ActionEvent e ) {
            response = responseField.getText();
            dialog.dispose();
         } // end actionPerformed
      } // end inner class uponEnterKeyPressedListener
    
   } // end class TextDialog
