   import java.util.*;
   import java.io.*;

    public class WordList {
      ArrayList words = null;
      int [] randomWordOrder;
      int nextRandomIndex = 0;
   
       public WordList(String fileName) throws IOException {
         loadWords(fileName);
         generateRandomOrder();
			nextRandomIndex = 0;
      } // end WordList constructor
    
       private void generateRandomOrder() {
         randomWordOrder = new int[words.size()];
         for (int i = 0; i < words.size(); i++ ) {
            randomWordOrder[i] = i;
         } // end for
      
      // randomize the array
         for (int i = 0; i < words.size(); i++) {
            Random random = new Random();
            int randomIndex =  (int) (random.nextFloat() * words.size());
            int temp = randomWordOrder[i];
            randomWordOrder[i] = randomWordOrder[randomIndex];
            randomWordOrder[randomIndex] = temp;
         } // end for
      
       } // end generateRandomOrder
   
   
       public void loadWords(String fileName) throws IOException {
         words = new ArrayList();
         String delimiters = " \t\n";
         BufferedReader inputFile = new BufferedReader( new FileReader( fileName ) );
 
         String buffer = null;
      
         while( true ) {
            buffer = inputFile.readLine();
         
            if ( buffer == null ) 
               break;
         
            buffer = buffer.toUpperCase();
            StringTokenizer tokens = new StringTokenizer( buffer, delimiters );
         
            while( tokens.hasMoreElements() ) {
               String word = tokens.nextToken();
               words.add( (String) word );
            } // end while
         } // end while
      
      } // end loadWords
    
       public String getRandomWord( ) {
         String value = (String) words.get(randomWordOrder[nextRandomIndex]);	  
         nextRandomIndex = (nextRandomIndex + 1) % words.size();
         return value;
      } // end getRandomWord
   } // end class WordList